/*
 * Target pro downloader TS02 II
 *
 * Author: DevCom spol. s r.o., Jan Damborsky
 *
 * Notes:	
 *
 * Version: 1.0
 * 
 * Created: 12.5.2004
 * Last modification: 9.8.2004
 */

#ifndef __ASSEMBLY__
#include "mcf5xxx.h"
#endif /* __ASSEMBLY__ */

/* 
 * System Bus Clock Info 
 */
#define	SYSTEM_CLOCK			66355	/* system bus frequency in kHz */
#define PERIOD					45.212	/* system bus period in ns */
#define UART_BAUD				115200

#define LED_PIN					0x20

#ifndef __ASSEMBLY__
/* 
 * Memory map definitions from linker command files 
 */
extern uint8 __IPSBAR[];
extern uint8 __SDRAM[];
extern uint8 __SDRAM_SIZE[];
extern uint8 __SRAM[];
extern uint8 __SRAM_SIZE[];
extern uint8 __EXT_SRAM[];
extern uint8 __EXT_SRAM_SIZE[];
extern uint8 __FLASH[];
extern uint8 __FLASH_SIZE[];
extern uint8 __EXT_FLASH[];
extern uint8 __EXT_FLASH_SIZE[];
extern uint8 __TEXT_START[];
extern uint8 __APP_FC_TABLE[];
extern uint32 __FLASH_LOADER_OFFSET;

//extern char __TEXT_START[];
extern char __DATA_ROM[];
extern char __DATA_RAM[];
extern char __DATA_END[];
extern char __BSS_START[];
extern char __BSS_END[];
extern uint32 VECTOR_TABLE[];
extern uint32 __VECTOR_RAM[];
#endif /* __ASSEMBLY__ */

/* 
 * Memory Map Info 
 */
#define IPSBAR_ADDRESS			(uint32)__IPSBAR

#define SDRAM_ADDRESS			(uint32)__SDRAM
#define SDRAM_SIZE				(uint32)__SDRAM_SIZE

#define SRAM_ADDRESS			(uint32)__SRAM
#define SRAM_SIZE				(uint32)__SRAM_SIZE

#define EXT_SRAM_ADDRESS		(uint32)__EXT_SRAM
#define EXT_SRAM_SIZE			(uint32)__EXT_SRAM_SIZE

#define FLASH_ADDRESS			(uint32)__FLASH
#define FLASH_SIZE				(uint32)__FLASH_SIZE
/* 64kB available for Loader */
/* offset zacatku loaderu */
//#define FLASH_LOADER_OFFSET		0x00
#define FLASH_LOADER_OFFSET		0x40000
#define FLASH_LOADER_SIZE		(uint32)0x10000
#define FLASH_LOADER_TOP		(uint32)(__FLASH + FLASH_LOADER_SIZE - 1)

#define EXT_FLASH_ADDRESS		(uint32)__EXT_FLASH
#define EXT_FLASH_SIZE			(uint32)__EXT_FLASH_SIZE

/* size of Compact Flash unit (sector) */
#define FLASH_CF_BLK_SIZE	512

/* num of Boot region in sectors */
#define FLASH_CF_BOOT_SIZE	1

/* THS10064 ADC for scope - 0xfa20.0000, 64kB, 16bit port */
#define ADC_BASE_ADDRESS		(uint32)0xfa200000
#define ADC_SIZE				(uint32)0x10000

/* IDE Compact Flash registers - 0xfa21.0000, 64kB, 16bit port */
#define IDE_BASE_ADDRESS		(uint32)0xfa210000
#define IDE_SIZE				(uint32)0x10000

/* IDE Compact Flash ALT STATUS register - 0xfa22.0000, 64kB, 16bit port */
#define IDE_ALTSTS_BASE_ADDRESS	(uint32)0xfa220000
#define IDE_ALTSTS_SIZE			(uint32)0x10000

/* display registers - 0xfa23.0000, 64kB, 8bit port */
#define DISPLAY_BASE_ADDRESS	(uint32)0xfa230000
#define DISPLAY_SIZE			(uint32)0x10000

/*
 *	Interrupt Controller Definitions
 */
#define TIMER_NETWORK_LEVEL		3
#define FEC_LEVEL				4

/*
 *	Timer period info
 */
#define TIMER_NETWORK_PERIOD	1000000000/0x10000	/* 1 sec / max timeout */


#define KILO    * (1024UL     )
#define MEGA    * (1024UL KILO)
#define GIGA    * (1024UL MEGA)

#define INST_PER_SEC    3000000L
#define VECTOR_NUMBER   96

#define TARGET_NAME     "Downloader"

#define ROM_BASE        ( 0x0 )
#define ROM_SIZE        ( 512 KILO )
#define ROM             ( *(const unsigned char(*)[ROM_SIZE])ROM_BASE )

#define RAM_BASE        ( 0x10000000 )
#define RAM_SIZE        ( 32 KILO )
#define RAM             ( *(unsigned char(*)[RAM_SIZE])RAM_BASE )

#define CSINTERN_BASE		0xfffff000L
#define INTERN_BASE		( CSINTERN_BASE )
#define INTERN			( *(struct mc68340 *)INTERN_BASE )

#define TIMER_NETWORK_PERIOD	1000000000/0x10000	/* 1 sec / max timeout */
